import {
  describe,
  expect,
  injectAsync,
  it,
  setBaseTestProviders,
  TestComponentBuilder
} from 'angular2/testing';
import {Component, View} from 'angular2/core';
import {DOM} from 'angular2/src/platform/dom/dom_adapter';
import {AboutCmp} from './about';
import {NameList} from '../../services/name_list';
import {} from 'angular2/testing';
import {
  TEST_BROWSER_PLATFORM_PROVIDERS,
  TEST_BROWSER_APPLICATION_PROVIDERS
} from 'angular2/platform/testing/browser';
setBaseTestProviders(TEST_BROWSER_PLATFORM_PROVIDERS,
                     TEST_BROWSER_APPLICATION_PROVIDERS);


export function main() {
  describe('About component', () => {
    it('should work', injectAsync([TestComponentBuilder], (tcb: TestComponentBuilder) => {
      return tcb.overrideTemplate(TestComponent, '<div><about></about></div>')
        .createAsync(TestComponent)
        .then((rootTC) => {
          rootTC.detectChanges();

          let aboutInstance = rootTC.debugElement.componentViewChildren[0].componentInstance;
          let aboutDOMEl = rootTC.debugElement.componentViewChildren[0].nativeElement;

          let nameListLen = function () {
            return aboutInstance.list.names.length;
          };

          expect(aboutInstance.list).toEqual(jasmine.any(NameList));
          expect(nameListLen()).toEqual(4);
          expect(DOM.querySelectorAll(aboutDOMEl, 'li').length).toEqual(nameListLen());

          aboutInstance.addName({value: 'Minko'});
          rootTC.detectChanges();

          expect(nameListLen()).toEqual(5);
          expect(DOM.querySelectorAll(aboutDOMEl, 'li').length).toEqual(nameListLen());
          expect(DOM.querySelectorAll(aboutDOMEl, 'li > span')[4].textContent).toEqual('Minko');
        });
    }));
  });
}

@Component({providers: [NameList], selector: 'test-cmp'})
@View({directives: [AboutCmp]})
class TestComponent {}
